level110:
	LDA $141D
	BEQ .bridge	; intro
	LDA $141A
	BNE .bridge	; not init
	INC $141A
	STZ $19
	STZ $0DC2
.bridge
	LDA $0DC2
	BEQ +
	STZ $0EFA
+
	LDA $0EFA
	BEQ +
	STA $7FA2E0
	LDA #$78
	STA $02E0
	LDA #$0F
	STA $02E1
	LDA #$2E
	STA $02E2
	LDA #$30
	STA $02E3
	LDA #$02
	STA $0458
	BRA .ingame
+
	LDA #$FC
	STA $7FA2E0
.ingame
	LDA $9D
	ORA $13D4
	BEQ +
	JMP .draw
+
	LDA $16
	AND #$20
	BNE +
	JMP .passive
+
	LDA $0EFA
	BNE +
	JMP .passive
+
	LDA $0EFB
	BEQ +
	JMP .passive
+
	REP #$20
	LDA $1A
	CLC
	ADC #$0078
	STA $00
	AND #$000F
	CMP #$0008
	BCS +
	LDA $00
	AND #$FFF0
	STA $00
	STA $0EFE	; x1
	STA $0F00	; x2
	BRA ++
+
	LDA $00
	AND #$FFF0
	CLC
	ADC #$0010
	STA $00
	STA $0EFE	; x1
	STA $0F00	; x2
++
	LDA $1C
	CLC
	ADC #$000F
	STA $02
	AND #$000F
	CMP #$0008
	BCS +
	LDA $02
	AND #$FFF0
	STA $02
	STA $0F02	; y
	BRA ++
+
	LDA $02
	AND #$FFF0
	CLC
	ADC #$0010
	STA $02
	STA $0F02	; y
++
	SEP #$20
	JSR .get_map16
	JSR .overwritable
	BNE +
	LDA #$0C
	STA $1DFC
	DEC $0EFA
	LDA #$10
	STA $0EFB	; time
	LDA #$01
	STA $0EFC	; s1
	STA $0EFD	; s2
	BRA .passive
+
	LDA #$2A
	STA $1DFC
.passive
	LDX #$01
	LDY #$02
-
	LDA $0EFC,x
	BEQ ++
	LDA $0EFB
	AND #$07
	BNE +
	; create block
	REP #$20
	LDA $0EFE,y
	STA $9A
	LDA $0F02
	STA $98
	SEP #$20
	LDA #$0D
	STA $9C
	PHY
	JSL $00BEB0
	PLY
	; check the next map16
	REP #$20
	LDA $0EFE,y
	CLC
	ADC .table1,y
	STA $00
	LDA $0F02
	STA $02
	SEP #$20
	JSR .get_map16
	JSR .overwritable
	BEQ +
	STZ $0EFC,x
	BRA ++
+
	; move
	REP #$20
	LDA $0EFE,y
	CLC
	ADC .table2,y
	STA $0EFE,y
	SEP #$20
	LDA $0EFB
	AND #$03
	BNE ++
	LDA #$1A
	STA $1DF9
++
	DEY
	DEY
	DEX
	BPL -

	LDA $0EFB
	BEQ +
	DEC $0EFB
	BRA .draw
+
	STZ $0EFC
	STZ $0EFD
.draw
	LDX #$01
	LDY #$02
-
	LDA $0EFC,x
	BEQ +++

	REP #$20
	LDA $0EFE,y
	SEC
	SBC $1A
	STA $00
	CMP #$FFF0	; allowing -0010~0100
	BCS +
	CMP #$0100
	BCC +
	SEP #$20
	BRA ++
+
	LDA $0F02
	DEC
	SEC
	SBC $1C
	STA $02
	CMP #$FFF0	; allowing -0010~00F0
	BCS ++
	CMP #$00F0
	BCC ++
	SEP #$20
	BRA +++
++
	SEP #$20
	PHY
	LDY .table3,x
	LDA $00
	STA $0200,y
	LDA $02
	STA $0201,y
	LDA #$2E
	STA $0202,y
	LDA #$30
	STA $0203,y

	TYA
	LSR
	LSR
	TAY
	LDA $01
	BNE .off
	LDA #$02
	STA $0420,y
	PLY
	BRA +++
.off
	LDA #$03
	STA $0420,y
	PLY
+++
	DEY
	DEY
	DEX
	BPL -
	RTS
.table1
	dw $0010,$FFF0
.table2
	dw $0002,$FFFE
.table3
	db $40,$44

; input: $00 (x, 16bit) $02 (y, 16bit)
; output: $04 (map16 num, 16bit)
.get_map16
	PHP
	REP #$10
	PHX
	SEP #$20
	LDA $5B
	AND #$01
	BNE .get_map16_vert
.get_map16_horz
	LDA $01
	STA $4202
	LDA #$1B
	STA $4203
	NOP	; waste 8 cycles for multiplication
	NOP
	NOP
	NOP
	REP #$20
	LDA $4216
	ASL
	ASL
	ASL
	ASL
	STA $04

	LDA $00
	AND #$00F0
	LSR
	LSR
	LSR
	LSR
	CLC
	ADC $02
	CLC
	ADC $04
	STA $04

	LDX $04
	SEP #$20
	LDA $7EC800,x
	STA $04
	LDA $7FC800,x
	STA $05

	PLX
	PLP
	RTS
.get_map16_vert
	LDA $03
	ASL
	ORA $01
	STA $05

	LDA $00
	LSR
	LSR
	LSR
	LSR
	ORA $02
	STA $04

	LDX $04
	LDA $7EC800,x
	STA $04
	LDA $7FC800,x
	STA $05

	PLX
	PLP
	RTS

; input: $04 (map16 num, 16bit)
; output: flag (BEQ = overwritable)
.overwritable
	LDA $05
	CMP #$07
	BEQ ++
	CMP #$00
	BNE +++
	LDA $04
	CMP #$21
	BCC .false
	CMP #$26
	BCS +
	LDA #$00
	RTS
+
	CMP #$6A
	BCC .false
	CMP #$6E
	BCS .false
	LDA #$00
	RTS
.false
	LDA #$01
	RTS
++
	LDA $04
	CMP #$18
	BCC .false
	CMP #$1C
	BCS .false
	LDA #$00
+++
	RTS
